<template>
  <div class="spot-list">
    <ObTable
      :columns="columns"
      :items="spotTableItems"
      :table-height="tableHeight"
      :functional-panel="true"
      :is-functional-sort="false"
      :is-functional-group="false"
      :loading="loadingData"
      :filter-buttons="tabs"
      @select="selectSpot"
      @on-change-filter-button="onChangeFilterButton"
    >
      <template #notification="{ data }">
        <notificationSlot :item="data.item" />
      </template>
      <template #draftLifetime="{ data }">
        <draftLifetimeSlot :item="data.item" />
      </template>
      <template #route="{ data }">
        <routeSlot :item="data.item" />
      </template>
      <template #fromDt="{ data }">
        <dateFromSlot :item="data.item" />
      </template>
      <template #contractorTitle="{ data }">
        <contractorTitleSlot :item="data.item" />
      </template>
      <template #auctionType="{ data }">
        <auctionTypeSlot :item="data.item" />
      </template>
      <template #currentPrice="{ data }">
        <currentPriceSlot :item="data.item" />
      </template>
      <template #temperature="{ data }">
        <temperatureSlot :item="data.item" />
      </template>
      <template #requirements="{ data }">
        <requirementsSlot :item="data.item" />
      </template>
      <template #noneContent>
        <div
          class="none-content-text"
          v-if="!areSpotTableItems && !loadingData"
        >
          {{ noneContentText }}
        </div>
      </template>
    </ObTable>
  </div>
</template>

<script>
import api from '@/api'
import ObTable from 'common-components/src/obComponents/obTable'
import { mapActions } from 'vuex'
import notificationSlot from '../../slots/notification'
import auctionTypeSlot from '../../slots/auctionType'
import currentPriceSlot from '../../slots/currentPrice'
import routeSlot from '../../slots/route'
import requirementsSlot from '../../slots/requirements'
import temperatureSlot from '../../slots/temperature'
import dateFromSlot from '../../slots/dateFrom'
import contractorTitleSlot from '../../slots/contractorTitle'
import draftLifetimeSlot from '../../slots/draftLifetime'

export default {
  components: {
    ObTable,
    notificationSlot,
    auctionTypeSlot,
    currentPriceSlot,
    routeSlot,
    requirementsSlot,
    temperatureSlot,
    dateFromSlot,
    contractorTitleSlot,
    draftLifetimeSlot,
  },
  props: {
    columns: {
      type: Array,
    },
  },
  data() {
    return {
      loadingData: true,
      showPanel: true,
      selectedSpot: {},
      uploadTableItemsTimer: null,
      spotAuctionTimer: null,
      initFilters: {
        sortField: 'updated_at',
        sortDirection: 'desc',
        lotStatus: 'ALL',
      },
      tabs: [
        {
          id: 'ALL',
          title: 'Все',
          _isActive: true,
        },
        {
          id: 'ENDS',
          type: 'clock',
          html: '<i class="icon clock -light-raspberry-red"></i>',
        },
        {
          id: 'LOSING',
          title: 'Ставка перебита',
        },
      ],
    }
  },
  computed: {
    ...mapGetters({
      spotTableItems: 'spot/spotTableItems',
      spotAuction: 'spot/spotAuctionByCarrier',
      spotFilter: 'spot/carrierFilter',
    }),
    isSpotListActual() {
      return this.$route.path === '/spot-list'
    },
    areSpotTableItems() {
      return !!this.spotTableItems.length
    },
    noneContentText() {
      return this.isSpotListActual
        ? 'У вас нет актуальных спот-аукционов'
        : 'У вас нет завершенных спот-аукционов'
    },
    tableHeight() {
      return this.showPanel
        ? window.innerHeight - 430
        : window.innerHeight - 310
    },
  },
  async created() {
    await this.uploadSpots()
    .then(() => {
      this.uploadTableItemsTimer = setInterval(
        async function() {
          await this.updateTableItems()
        }.bind(this), 5000)

      this.spotAuctionTimer = setInterval(
        async function() {
          await this.updateSpotAuction()
        }.bind(this), 5000)
    })
  },
  beforeDestroy() {
    clearInterval(this.spotAuctionTimer)
    clearInterval(this.uploadTableItemsTimer)
  },
  methods: {
    ...mapActions({
      getSpotOrder: 'spot/getSpotOrderByCarrier',
      getSpotAuction: 'spot/getSpotAuctionByCarrier',
      getSpotBidsInfo: 'spot/getSpotBidsInfoByCarrier',
      getSpotTableItems: 'spot/getSpotTableItemsByCarrier',
    }),
    ...mapMutations({
      setSpotFilter: 'spot/SET_SPOT_CARRIER_FILTER',
      setSpotAuction: 'spot/SET_SPOT_AUCTION_CARRIER',
      setSpotTableItems: 'spot/SET_SPOT_TABLE_ITEMS',
    }),
    async selectSpot(spot) {
      this.selectedSpot = spot
      await this.getSpotOrder(this.selectedSpot)
      await this.getSpotAuction(this.selectedSpot.auctionUuid)
      await this.getSpotBidsInfo({
        auctionUuid: this.selectedSpot.auctionUuid,
        orderUuid: this.selectedSpot.spotOrder.orderUuid,
      })
    },
    async onChangeFilterButton(e) {
      this.tabs.map((button) => (button._isActive = false))
      e._isActive = true
      this.initFilters.lotStatus = e.id
      await this.uploadSpots()
    },
    async uploadSpots() {
      try {
        const filters = Object.assign(this.initFilters, this.spotFilter)

        this.isSpotListActual
          ? (filters.tabType = 'actual')
          : (filters.tabType = 'ended')

        this.setSpotFilter(filters)

        await this.getSpotTableItems(filters)
        .then(() => {
          if (this.areSpotTableItems) {
            this.selectSpot(this.spotTableItems[0])
          } else {
            this.setSpotTableItems([])
            clearInterval(this.spotAuctionTimer)
          }
        })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных',
        })
        this.setSpotTableItems([])
        clearInterval(this.spotAuctionTimer)
      }
      this.loadingData = false
    },
    async updateTableItems() {
      const spotTableItems = await api.spotAuction.getSpotsByCarrier(this.spotFilter)
      this.setSpotTableItems(spotTableItems)
    },
    async updateSpotAuction() {
      if(this.areSpotTableItems) {
        const spotAuction = await api.spotAuction.getSpotAuctionByCarrier(this.selectedSpot.auctionUuid)
        this.setSpotAuction(spotAuction)
      }
    },
    sizeTable() {
      this.showPanel = !this.showPanel
    }
  },
}
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
.spot-tabs {
  display: flex;
  width: 100%;
  &__item {
    display: flex;
    justify-content: center;
    align-self: center;
    height: 30px;
    font-size: 14px;
    line-height: 16px;
    color: $color-blue-navy-blue;
    padding: 7px 12px;
    border: 1px solid $color-grey-border;
    box-sizing: border-box;
    text-overflow: ellipsis;
    white-space: nowrap;
    overflow: hidden;
    cursor: pointer;
    span {
      margin-left: 0;
    }
    &:first-child {
      border-radius: 3px 0 0 3px;
    }
    &:nth-child(5) {
      border-radius: 0 3px 3px 0;
    }
    &:last-child {
      border-radius: 3px;
      margin-left: 10px;
    }
    &-active {
      border: none;
      background: $blue-blue-hoarfrost;
      box-shadow: inset 0 4px 4px rgba(0, 75, 200, 0.3);
    }
    &-disabled {
      cursor: default;
      color: $gray-window;
      background: $color-white-lilac;
      pointer-events: none;
    }
    &-caution {
      position: relative;
      &:after {
        content: '';
        position: absolute;
        width: 6px;
        height: 6px;
        background: $color-green-light;
        border-radius: 50%;
        margin-left: 2px;
      }
    }
    & > i.clock {
      font-size: 16px;
      font-weight: bold;
      &::before {
        color: $color-error;
      }
    }
  }
}
.ob-func-panel {
  &__controls {
    justify-content: flex-start;
    &-side {
      &:first-child {
        .ob-func-panel__control {
          &:nth-child(1) {
            margin-left: 8px;
          }
          &:nth-child(2) {
            display: none;
          }
          &:nth-child(4) {
            display: none;
          }
        }
      }
      &:last-child {
        width: 100%;
        .ob-func-panel__control {
          &:first-child {
            width: 100%;
          }
        }
      }
    }
  }
  .assigning {
    .spot-tabs__item {
      &:nth-child(4),
      &:last-child {
        display: none;
      }
    }
  }
}
table {
  min-width: auto;
}
.table-panel-inner::-webkit-scrollbar {
  width: 6px;
  background: transparent;
  opacity: 0.3;
}
.table-panel-inner::-webkit-scrollbar-thumb {
  background: $blue-200;
  border-radius: 3px;
}
.table-panel-inner::-webkit-scrollbar-track {
  background: transparent;
}
.table-data th {
  &:nth-child(7) {
    display: none;
    @media screen and (min-width: 1920px) {
      display: block;
    }
  }
}
.table-data td {
  &:nth-child(7) {
    display: none;
    @media screen and (min-width: 1920px) {
      display: block;
    }
  }
}
.none-content-text {
  margin-bottom: 20px;
  font-size: 18px;
  line-height: 29px;
  color: $color-grey-span;
  letter-spacing: 0.4px;
}
</style>
